
#pragma once
#include "JuceHeader.h"
#include "MainComponent.h"

class EditorContent : public juce::Component
{
public:
    EditorContent() 
    {
        setSize(600, 400);
    }

    ~EditorContent() {}

    void paint(juce::Graphics& g) override
    {
        g.setColour(findColour(juce::Label::textColourId));
        g.drawText("This is EditorWindow.", getLocalBounds(), juce::Justification::centred);
    }
};

class PluginEditorWindow :public juce::DocumentWindow
{
public:
    PluginEditorWindow(MainComponent& main_component)
        : DocumentWindow("PluginWindow", juce::LookAndFeel::getDefaultLookAndFeel().findColour(juce::DocumentWindow::backgroundColourId),
            DocumentWindow::minimiseButton | DocumentWindow::closeButton),
        main_component_(main_component)

    {
        setContentOwned(new EditorContent(), true);
        setVisible(true);
        setAlwaysOnTop(true);
    }

    ~PluginEditorWindow() override
    {
        clearContentComponent();
    }

    void closeButtonPressed() override
    {
        main_component_.SetEditorVisible(false);
    }

private:
    float getDesktopScaleFactor() const override { return 1.0f; }

    MainComponent& main_component_;
};